// Code by DragonMinded
// Please attribute, nothing more

#ifndef __DRAWABLE_H
#define __DRAWABLE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <image.h>

#include "text.h"
#include "color.h"

using namespace wsp;

class DrawableImage
{
	public:
		DrawableImage();
		~DrawableImage();
		
		void createImage(int width, int height);
		
		u32 getWidth();
		u32 getHeight();
		bool isInitialized();
		void BindTexture(bool bilinear = true);
		
		Image *getImage();
		void copyBuffer(u8 *buf);
		
		void setFont(const char *f);
		void setColor(Color c);
		void setSize(int s);
		void renderText(const char *fmt, ...);
	private:		
		u32 _width, _height;
		bool _initialized;
		GXTexObj _texObj; 
		u8* _pixels;
		
		TextRender font;
};

#ifdef __cplusplus
}
#endif

#endif


