// Code by DragonMinded
// Please attribute, nothing more

#ifndef __TEXTRENDER_H
#define __TEXTRENDER_H

#ifdef __cplusplus
extern "C" {
#endif

#define DEFAULT_X 5
#define DEFAULT_Y 5

#define DEFAULT_Y_CUSHION 2
#define DEFAULT_TAB_SPACE 50

#include <stdint.h>
#include <ft2build.h>
#include FT_FREETYPE_H

#include "color.h"

class TextRender
{
	public:
		TextRender();
		~TextRender();
		
		void setFont(const char *font);
		void setColor(Color c);
		void setSize(int s);
		
		void setBuffer(uint8_t *buf, int width, int height);
		void renderSimple(const char *out);
		void render(const char *fmt, ...);
	protected:
		void Blit(FT_Bitmap *bmp, int bmpWidth, int bmpHeight);
		
		FT_Library library;
		FT_Face face;
		
		uint8_t *_buf;
		int _width;
		int _height;
		int _fontheight;
		Color _color;
};

#ifdef __cplusplus
}
#endif

#endif


